
/*4、Stata调用curl进行Boson分词*/
di "`=ustrtohex("武汉市长江大桥")'"
clear
cd E:\Stata教程\文本分析
! curl -X POST -H "Content-Type: application/json" ///
	-H "Accept: application/json" ///
	-H "X-Token: iWvPMLa2.17141.Jsa8f8dzLqov" ///
	--data "\"`=ustrtohex("武汉市长江大桥")'\"" ///
	"http://api.bosonnlp.com/tag/analysis?space_mode=1&oov_level=3&t2s=0" ///
	-o 分词结果.txt
shellout 分词结果.txt
import delimited using 分词结果.txt, clear encoding("utf8") ///
	varnames(nonames) delimiter("asdfghjkl", asstring)
split v1,p(`""],""')	
drop v1
sxpose,clear
rename _var1 v
replace v = ustrregexra(v, `"("\]\}\])|("\])|(\[")|"|(")|(\[\{)"', "")
split v,p(":" ",")	
drop v
sxpose,clear
nrow 1
rename * (词 词性)	
***********词频统计
levelsof 词, local(词)
bysort 词: gen frequency = _N
duplicates drop

*********************************
*************读入文本进行Boson分词
**********************************
clear
cd E:\Stata教程\文本分析
set obs 1
gen v = fileread("荷塘月色.txt")
replace v = ustrregexra(v, "\r|\n", "")
! curl -X POST -H "Content-Type: application/json" ///
	-H "Accept: application/json" ///
	-H "X-Token: iWvPMLa2.17141.Jsa8f8dzLqov" ///
	--data "\"`=ustrtohex("`=v[1]'")'\"" ///
	"http://api.bosonnlp.com/tag/analysis?space_mode=1&oov_level=3&t2s=0" ///
	-o 分词结果.txt
shellout 分词结果.txt
import delimited using 分词结果.txt, clear encoding("utf8") ///
	varnames(nonames) delimiter("asdfghjkl", asstring)
split v1,p(`""],""')	
drop v1
sxpose,clear
rename _var1 v
replace v = ustrregexra(v, `"("\]\}\])|("\])|(\[")|"|(")|(\[\{)"', "")
split v,p(":" ",")	
drop v
sxpose,clear
nrow 1
rename * (词 词性)	

***********词频统计
levelsof 词, local(词)
bysort 词: gen frequency = _N
duplicates drop

*******************************************************************************
*                                                                              *
*                                    *结束*                                  
*                                                                              *
********************************************************************************
